#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <bot.h>
#include <command.h>
#include <cstring>
#include <debug.h>

using namespace std;

void CommandManager::add(Command * cmd)
{
 mCommands.push_back(cmd);
}

void CommandManager::remove(std::string name)
{
 //TODO: implement
}

std::string CommandManager::execute(std::string name, std::string arg)
{
 Command * cmd;
 vector<Command*>::iterator iter;
 string result;
 if (name == "pomoc")
 {
  if (arg != "")
  {
   cmd = this->lookup(arg);
   if (!cmd)
   {
    return "Nie ma pomocy dla " + arg;
   }
   result = "Użycie: " + cmd->usage() + "\n" + cmd->help();
  }
  else
  {
   result = "List poleceń bota:\npomoc\tpokaż ten tekst pomocy\n";
   for(iter=mCommands.begin();iter!=mCommands.end();iter++)
   {
    cmd = *iter;
    result += cmd->name() + "\t" + cmd->help() + "\n";
   }
   result += "Aby uzyskać informacje o użyciu danego polecenia wpisz pomoc <polecenie>\n";
  }
  return result;
 }

 cmd = this->lookup(name);
 if (!cmd)
   return "Nieznane polecenie " + string(name) + "\nWpisz pomoc aby uzyskać listę dostępnych poleceń\n";

 return cmd->execute(arg);
}

Command * CommandManager::lookup(std::string name)
{
 vector<Command*>::iterator iter;
 Command * cmd;
 for(iter=mCommands.begin();iter!=mCommands.end();iter++)
 {
  cmd = *iter;
  if (cmd->name() == name)
     return cmd;
 }
 return NULL;
}
