#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <bot.h>
#include <debug.h>
#include <modStatus.h>

using namespace std;

#define BOT_JID  "bot@example.net"
#define BOT_PASS "password"
#define BOT_HOST "example.net"

int main(int argc, char ** argv)
{
 Bot * dugbot;
 ModStatus * mStatus;
 DEBUG("Starting bot...\n");

 dugbot = new Bot(BOT_JID, BOT_PASS, BOT_HOST);
 // Aktuwyjemy moduly
 // -> Mod Status
 mStatus = new ModStatus();
 dugbot->commandManager()->add(mStatus);

 try
 {
  dugbot->start();
 }
 catch(...)
 {
  delete dugbot;
  DEBUG("Exiting with error\n");
  return 1;
 }
 delete dugbot;
 DEBUG("Exiting without error\n");
 return 0;
}
